sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=61
left=241
tileSpacing=5
tile=1
caption="Kreistest / Circle"
End CompInit
Dim gadget1 as gadget
gadget1 = MakeComponent("gadget",form1)
CompInit gadget1
proto="gadget1"
width=200
height=200
visible=1
End CompInit
gadget1.name="gadget1"
Dim group1 as group
group1 = MakeComponent("group",form1)
CompInit group1
proto="group1"
caption=""
look=1
tile=1
tileLayout=1
sizeHControl=3
sizeVControl=3
tileSpacing=5
visible=1
End CompInit
Dim l_button as button
l_button = MakeComponent("button",group1)
CompInit l_button
proto="l_button"
caption="Kreis/Circle"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
l_button.name="l_button"
Dim button3 as button
button3 = MakeComponent("button",group1)
CompInit button3
proto="button3"
caption="gef. Kreis/filled"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button3.name="button3"
group1.name="group1"
Dim group2 as group
group2 = MakeComponent("group",form1)
CompInit group2
proto="group2"
caption="Werte:/values:"
look=1
tile=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim x_number as number
x_number = MakeComponent("number",group2)
CompInit x_number
proto="x_number1"
caption="x:"
sizeHControl=3
sizeVControl=3
value=50
maximum=400
visible=1
End CompInit
x_number.name="x_number"
Dim y_number as number
y_number = MakeComponent("number",group2)
CompInit y_number
proto="y_number"
caption="y:"
sizeHControl=3
sizeVControl=3
value=50
maximum=400
visible=1
End CompInit
y_number.name="y_number"
Dim r_number as number
r_number = MakeComponent("number",group2)
CompInit r_number
proto="r_number"
caption="r:"
sizeHControl=3
sizeVControl=3
value=10
maximum=200
visible=1
End CompInit
r_number.name="r_number"
Dim group3 as group
group3 = MakeComponent("group",group2)
CompInit group3
proto="group3"
caption="Farbe:/color:"
look=1
tile=1
sizeHControl=0
tileSpacing=5
sizeVControl=3
width=102
visible=1
End CompInit
Dim f_label as label
f_label = MakeComponent("label",group3)
CompInit f_label
proto="f_label"
caption="???"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
f_label.name="f_label"
Dim c_number as number
c_number = MakeComponent("number",group3)
CompInit c_number
proto="c_number"
caption="c: "
sizeHControl=3
sizeVControl=3
value=16
minimum=1
maximum=20
visible=1
End CompInit
c_number.name="c_number"
group3.name="group3"
group2.name="group2"
form1.width=218
form1.height=405
form1.name="form1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here
CONST OEOP 57.2958
dim farbwahls[21] as string
dim farbwahlc[21] as long

farbwahls[1] = "BLACK"
farbwahls[2] = "WHITE"
farbwahls[3] = "GRAY_50"
farbwahls[4] = "GREY_50"
farbwahls[5] = "DARK_GRAY"
farbwahls[6] = "LIGHT_GRAY"
farbwahls[7] = "DARK_GREY"
farbwahls[8] = "LIGHT_GREY"
farbwahls[9] = "DARK_GREEN"
farbwahls[10] = "LIGHT_GREEN"
farbwahls[11] = "DARK_BLUE"
farbwahls[12] = "LIGHT_BLUE"
farbwahls[13] = "DARK_CYAN"
farbwahls[14] = "LIGHT_CYAN"
farbwahls[15] = "DARK_PURPLE"
farbwahls[16] = "LIGHT_PURPLE"
farbwahls[17] = "DARK_RED"
farbwahls[18] = "LIGHT_RED"
farbwahls[19] = "BROWN"
farbwahls[20] = "YELLOW"

farbwahlc[1] = BLACK
farbwahlc[2] = WHITE
farbwahlc[3] = GRAY_50
farbwahlc[4] = GREY_50
farbwahlc[5] = DARK_GRAY
farbwahlc[6] = LIGHT_GRAY
farbwahlc[7] = DARK_GREY
farbwahlc[8] = LIGHT_GREY
farbwahlc[9] = DARK_GREEN
farbwahlc[10] = LIGHT_GREEN
farbwahlc[11] = DARK_BLUE
farbwahlc[12] = LIGHT_BLUE
farbwahlc[13] = DARK_CYAN
farbwahlc[14] = LIGHT_CYAN
farbwahlc[15] = DARK_PURPLE
farbwahlc[16] = LIGHT_PURPLE
farbwahlc[17] = DARK_RED
farbwahlc[18] = LIGHT_RED
farbwahlc[19] = BROWN
farbwahlc[20] = YELLOW

c_number_changed(c_number,16)

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub l_button_pressed(self as button)
	gadget1_draw(gadget1)
	DrawCircle(x_number.value,y_number.value,r_number.value,farbwahlc[c_number.value],0)
	DrawPoint(x_number.value,y_number.value,BLACK)
end sub

sub c_number_changed(self as number, value as integer)
	f_label.caption = farbwahls[c_number.value]
end sub

sub gadget1_draw(self as gadget)
	gadget1.DrawRect(0,0,200,200,YELLOW)
end sub

sub button3_pressed(self as button)
	gadget1_draw(gadget1)
	DrawCircle(x_number.value,y_number.value,r_number.value,farbwahlc[c_number.value],1)
	DrawPoint(x_number.value,y_number.value,BLACK)
end sub

sub DrawCircle(x as integer, y as integer, radius as integer, color as long, flag as integer)

rem flag = 0 -> leerer Kreis / empty circle
rem flag = 1 -> gefuellter Kreis / filled circle
rem             nur bis radius = 91 komplett gefuellt !
rem             only to radius = 91 correct filled !

dim x1 as integer
dim y1 as integer
dim count as integer
dim a as float

for count = 0 to 90

	a = count/OEOP
	x1 = COS(a)*radius
	y1 = SIN(a)*radius

	if flag = 0 then     rem leerer Kreis
		gadget1.DrawLine(x-x1,y-y1,x-x1,y-y1,color)
		gadget1.DrawLine(x-x1,y+y1,x-x1,y+y1,color)
		gadget1.DrawLine(x+x1,y+y1,x+x1,y+y1,color)
		gadget1.DrawLine(x+x1,y-y1,x+x1,y-y1,color)
	else                rem gefuellter Kreis
		gadget1.DrawHLine(x-x1,x+x1,y-y1,color)
		gadget1.DrawHLine(x-x1,x+x1,y+y1,color)
		gadget1.DrawVLine(y-y1,y+y1,x-x1,color)
		gadget1.DrawVLine(y-y1,y+y1,x+x1,color)
		
		dim dummy as float   rem to fill the circle on radius > 70
		dim x2 as integer    rem rem the DrawRect-action and you
		dim x3 as integer    rem see, what i mean
		dim y2 as integer
		dim y3 as integer
		dummy = (radius/sqr(2))-1
		x2 = x-dummy
		x3 = x+dummy
		y2 = y-dummy
		y3 = y+dummy
		gadget1.DrawRect(x2, y2, x3, y3, color)
	end if

next count

end sub

sub DrawPoint(x as integer, y as integer, color as long)
	gadget1.DrawLine(x,y,x,y,color)
end sub

